Package org.zkoss.bind.proxy

## Class ListProxy<E>

- java.lang.Object
- - org.zkoss.bind.proxy.AbstractCollectionProxy<E>
  - - org.zkoss.bind.proxy.ListProxy<E>

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Iterable<E>`, `java.util.Collection<E>`, `java.util.List<E>`, `javassist.util.proxy.Proxy`, `FormProxyObject`

      public class ListProxy<E>
      extends AbstractCollectionProxy<E>
      implements java.util.List<E>

  A list proxy
  Since:
    8.0.0
  Author:
    jumperchen
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.zkoss.bind.proxy.AbstractCollectionProxy

      `_dirty, isImmutableElements`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ListProxy​(java.util.Collection<E> origin, java.lang.annotation.Annotation[] callerAnnots)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `add​(int index, E element)` |
    `boolean` | `addAll​(int index, java.util.Collection<? extends E> c)` |
    `E` | `get​(int index)` |
    `int` | `indexOf​(java.lang.Object o)` |
    `protected java.util.Collection<E>` | `initCache()` |
    `int` | `lastIndexOf​(java.lang.Object o)` |
    `java.util.ListIterator<E>` | `listIterator()` |
    `java.util.ListIterator<E>` | `listIterator​(int index)` |
    `E` | `remove​(int index)` |
    `E` | `set​(int index, E element)` |
    `java.util.List<E>` | `subList​(int fromIndex, int toIndex)` |

    - ### Methods inherited from class org.zkoss.bind.proxy.AbstractCollectionProxy

      `add, addAll, cacheSavePropertyBinding, clear, collectCachedSavePropertyBinding, contains, containsAll, createProxyObject, getCache, getOriginObject, isEmpty, isFormDirty, iterator, onDataChange, onDirtyChange, remove, removeAll, replaceOrigin, resetFromOrigin, retainAll, setDirty, setFormOwner, setHandler, setPath, size, submitToOrigin, testEquals, toArray, toArray`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.Collection

      `parallelStream, removeIf, stream, toArray`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

    - ### Methods inherited from interface java.util.List

      `add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, replaceAll, retainAll, size, sort, spliterator, toArray, toArray`

- - ### Constructor Detail

    - #### ListProxy

          public ListProxy​(java.util.Collection<E> origin,
                           java.lang.annotation.Annotation[] callerAnnots)

  - ### Method Detail

    - #### initCache

          protected java.util.Collection<E> initCache()

      Specified by:
        `initCache` in class `AbstractCollectionProxy<E>`

    - #### addAll

          public boolean addAll​(int index,
                                java.util.Collection<? extends E> c)

      Specified by:
        `addAll` in interface `java.util.List<E>`

    - #### get

          public E get​(int index)

      Specified by:
        `get` in interface `java.util.List<E>`

    - #### set

          public E set​(int index,
                       E element)

      Specified by:
        `set` in interface `java.util.List<E>`

    - #### add

          public void add​(int index,
                          E element)

      Specified by:
        `add` in interface `java.util.List<E>`

    - #### remove

          public E remove​(int index)

      Specified by:
        `remove` in interface `java.util.List<E>`

    - #### indexOf

          public int indexOf​(java.lang.Object o)

      Specified by:
        `indexOf` in interface `java.util.List<E>`

    - #### lastIndexOf

          public int lastIndexOf​(java.lang.Object o)

      Specified by:
        `lastIndexOf` in interface `java.util.List<E>`

    - #### listIterator

          public java.util.ListIterator<E> listIterator()

      Specified by:
        `listIterator` in interface `java.util.List<E>`

    - #### listIterator

          public java.util.ListIterator<E> listIterator​(int index)

      Specified by:
        `listIterator` in interface `java.util.List<E>`

    - #### subList

          public java.util.List<E> subList​(int fromIndex,
                                           int toIndex)

      Specified by:
        `subList` in interface `java.util.List<E>`